<template>
	<b-container :fluid="true">
		<b-row class="full-height">
			<nav class="col-sm-2 d-none d-sm-block bg-light sidebar p-0">
				<div class="sidebar-sticky h-100">
					<b-button v-b-modal.new-email-modal variant="outline-custom-dark" class="m-2">
						New message
					</b-button>
					<b-button @click.stop.prevent="loadMessages" variant="outline-custom-dark"
							  class="m-2" style="margin-top: 0 !important;">
						<b-icon-arrow-clockwise/>
					</b-button>
					<ul class="nav flex-column">
						<li v-for="message in $store.state.volatile.messages.slice().reverse()"
							:key="message.pk"
							class="nav-item">
							<router-link
								class="nav-link"
								:to="{name: 'Mailbox', params: $route.params, query: {mailId: message.pk}}">

								<img v-if="message.is_inbound" src="@/assets/email_incoming.svg"
									 height="20" alt="Incoming email" class="m-1">
								<img v-else src="@/assets/email_outgoing.svg"
									 height="20" alt="Outgoing email" class="m-1">
								{{ message.subject }}<br/>
								<span class="text-muted"
									  style="font-size: 80%">{{ stringToDatetimeString(message.created_at) }}</span>
							</router-link>
						</li>
					</ul>
				</div>
			</nav>
			<MailContentsView/>
			<NewEmailModal @email-sent="loadMessages"/>
		</b-row>
	</b-container>
</template>

<script>
import {errorJsonToToast, stringToDatetimeString,} from '@/utils';
import MailContentsView from '@/components/MailContentsView';
import NewEmailModal from '@/components/NewEmailModal';
import {BIconArrowClockwise,} from 'bootstrap-vue';

export default {
	name: 'Mailbox',
	components: {MailContentsView, NewEmailModal, BIconArrowClockwise,},
	data() {
		return {
			stringToDatetimeString: stringToDatetimeString,
		};
	},
	methods: {
		loadMessages() {
			const folders = {
				inbox: 'inbound',
				sent: 'outgoing',
				all: 'all',
			};
			const folder = folders[this.$route.params.type] || folders['all'];
			console.debug('Loading messages from', folder);

			this.$http.get(`/messages/?folder=${folder}`)
				.then(r => {
					const data = r.data;
					console.debug('Got messages', data);
					this.$store.commit('volatile/setMessages', data);
				})
				.catch(e => {
					console.error('Failed to get messages', e);
					this.$bvToast.toast(errorJsonToToast(this, e), {
						title: 'Failed to get messages',
						variant: 'danger',
					});
				});

		},
	},

	mounted() {
		this.loadMessages();
	},
	watch: {
		$route() {
			this.loadMessages();
		},
	},
};
</script>

<style scoped>
.sidebar {
	z-index: 100;
	box-shadow: inset -1px 0 0 rgba(0, 0, 0, .1);
}

.sidebar-sticky {
	position: sticky;
	top: 0;
	overflow-x: hidden;
	overflow-y: auto;
	display: flex;
	flex-direction: column;
	justify-content: flex-start;
}

/*noinspection CssUnusedSymbol*/
.sidebar .nav-link.active {
	color: #5349a0;
}

.sidebar .nav-link {
	font-weight: 500;
	font-size: 1rem;
	color: #333333;
	transition: all .3s;
}
</style>
